<?php
	/* Picstory cfg */
	/* Thomas Pimmel 2017-2018 */
	require_once ("include/version.php");
	ini_set("default_charset","UTF-8");

	/* debug */
	// define ("DEBUG",false);	// affichage des avertissements coupés
	define ("PS_DEBUG",true);		// si en développement
	if (PS_DEBUG) {
		ini_set('display_errors', 1);
		error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
	}
	else
	{
		ini_set('display_errors', 0);
	}

	/* création d'un log */
	define ("PS_VERBOSE",false);	// mode bavard coupé
	//define ("PS_VERBOSE",true);
	//define("PS_LOGIT",false);		// pas de création d'un log pour picstory
	define("PS_LOGIT",true);

	/* Utilisation d'image réduites, demande imagemagick installé */
	/* PS_USEXS est obsolète */
	//define ("PS_USEXS",false);
	define ("PS_USEXS",true);
	//define ("PS_USEXL",0);
	define ("PS_USEXL",800);

	/* Découpage automatique de l'image lors de la copie */
	//define (PS_TRIM,false);
	define ("PS_TRIM",true);

	/* Méthodes asumées par le serveur */
	// 0 rendu direct
	// 1 file 'batch'
	// 2 script linux ou windows selon le flag
	//define ("PS_METHODS","0,1,2");			// gérées pour l'instant
	define ("PS_METHODS","0,1,2");

	/* option configuration d'imagemagick */
	define ("PS_CONVOPTS","-limit area 3GB");	//v0.99
	/* Configuration selon OS */
	switch (PHP_OS)
	{
		case "Darwin":
		case "Linux":
			/* chemin / noms des exécutables */
			/* Linux */
			define ("PS_WINDOWS",false);
			define ("PS_PATH","/usr/bin/");
			define ("PS_PHP",PS_PATH."php");
			define ("PS_ZIP",PS_PATH."zip");		// Version >1.10
			define ("PS_UNZIP",PS_PATH."unzip");		// Version >1.10
			define ("PS_CONVCMD",PS_PATH."convert");
			define ("PS_ATCMD",PS_PATH."nice -n 19 ".PS_PHP." -f script.php");
			define ("PS_COPYCMD","cp -f");
			define ("PS_DELETE","rm -f");
			define ("PS_FFCMD",PS_PATH."ffmpeg -loglevel panic");
			define ("PS_SHHEADER","#!/bin/bash");	// entête script
			define ("PS_REM","#");					// remarques
			define ("PS_ENDOFLINE","\n");			// sauts de lignes
			break;
		default:
			/* Windows ou autres ?*/
			define ("PS_WINDOWS",true);
			define ("PS_PATH","");
			define ("PS_CONVCMD","magick");
			define ("PS_ATCMD","start /low /b ..\binaries\php\php-win.exe -f script.php");
			//define ("PS_PHP","..\binaries\php\php-win.exe");	// test impossible
			define ("PS_COPYCMD","copy");
			define ("PS_DELETE","del /f");
			define ("PS_FFCMD","ffmpeg -loglevel panic");
			define ("PS_SHHEADER","@echo off");		// entête script
			define ("PS_REM","rem");						// remarques
			define ("PS_ENDOFLINE","\r\n");				// sauts de lignes
			break;
	}
	/* version du moteur de rendu */
	define ("PS_EV","enginev3");
	/* 1.04 adresse mise à jour */
	define ("PS_MAJADRS","https://ratlerie.be/dlpicstory");
	define ("PS_MAJPROXY","");
?>