<!DOCTYPE html>
<html>
<?php
/*	Mise à jour de Picstory
	(c) Thomas Pimmel 2018
	v2
*/
session_name('update'); 
session_start();
header("Cache-Control: no-cache, must-revalidate");
header("Cache-Control: post-check=0,pre-check=0");
header("Cache-Control: max-age=0");
header("Pragma: no-cache");
header("Expires: 0");
?> 
<head>
<title>Picstory : Update</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="data/idx.css" rel="stylesheet" type="text/css">
</head>
<body>
<?php
clearstatcache();
require_once("include/cfg.php");
if (file_exists("projects/users.php"))
{
	require_once("projects/users.php");
	$_SESSION['ADMlng']=$ADMlng;
}
else
{
	$_SESSION['ADMlng']="fr";
	$_SESSION['$ADMMdp']="";
	$ADMlng="fr";
	$ADMMdp="";
}
$_SESSION['ADMtrans']=array();
if (!defined("PS_MAJADRS"))				define ("PS_MAJADRS","https://ratlerie.be/dlpicstory");
if (!isset($_SESSION['phase']))	$_SESSION['phase']=0;
if ($_SESSION['phase']==0 && $ADMMdp=="")		$_SESSION['phase']=2;	// passer phase 0 et 1

/* Phases de l'UPDATE */
print(($_SESSION['phase']+1)."/6<br><br>");

switch ($_SESSION['phase'])
{
	case 0:			/* Phase d'identification */
		print(_translate("Mise à jour de Picstory... Identification"));
		$_SESSION['phase']++;
		ask_mdp();
		break;
	case 1:		/* Vérification ident */
		print(_translate("Mise à jour de Picstory... vérification de l'identification.")."<br>");
		/* contrôle de l'identifiant */
		if (!isset($_POST['password']) || hash('sha256',$_POST['password'])!=$ADMMdp)
		{
			print(_translate("Mot de passe incorrect !"));
			ask_mdp();
			break;
		}
		else	$_SESSION['phase']++;
		// Pas de Break laisser coller !
	case 2:	/* Temporisation pour avertissement */
		ask_something(_translate("Attention ! Assurez-vous que plus personne n'utilise Picstory et qu'aucune tâche ne soit en cours ! Dans le cas contraire, attendez avant de faire la mise à jour."),_translate("Compris"),'picstoryupdate.php');
		$_SESSION['phase']++;
		break;
	case 3:	/* confirmé ! Récupération archive et nouveau fichier de config */
	// si installation précédente a échoué
		rrm("*.zip");
		rrm("picstory");
	// go cuillère à pot test de version
		printRT(_translate("Mise à jour de Picstory..."));
		$version=str_replace("\n","",file_get_contents(PS_MAJADRS."/VERSION"));
		if ($version===false)
		{
			$_SESSION=array();
			exit(_translate("Erreur de chargement du fichier VERSION"));
		}
		$_SESSION['version']=$version;
		$oldversion=PS_VERSION*100;
		if ($oldversion>=$version)
		{
			$_SESSION=array();
			exit(_translate("Votre version est la plus récente !"));
		}
	/* Téléchargement */
		printRT("Téléchargement de l'archive ".PS_MAJADRS."/picstory$version.zip");
		if (!ps_exec("wget ".PS_MAJADRS."/picstory$version.zip"))
		{
			rrm("*.zip");
			$_SESSION=array();
			exit (_translate("Erreur du chargement de l'archive"));
		}
		printRT(_translate("Décompression")."<br>");
		if (!ps_exec("unzip picstory$version.zip",true))
		{
			rrm("*.zip");
			rrm("picstory");
			$_SESSION=array();
			exit (_translate("Erreur lors de la décompression")." (1).");
		}
		// copie de la nouvelle version de l'installeur
		printRT(_translate("Mise à jour de l'installeur")."<br>");

		if (!moveit("picstory/picstoryupdate.php","./picstoryupdatenew.php"))
		{
			rrm("*.zip");
			rrm("picstory");
			$_SESSION=array();
			exit (_translate("Erreur lors de la décompression")." (2).");
		}
		ask_something(_translate("Prêt pour la mise à jour du programme"),_translate("Ok"),'picstoryupdatenew.php');
		$_SESSION['phase']++;
		break;
	case 4:	/* Propre à la nouvelle version de l'installeur */
		printRT(_translate("Mise à jour de Picstory... Copie des fichiers")."<br>");
		// configuration
		moveit("include/version.php","include/version.old");
		moveit("include/cfg.php","include/cfg.old");
		ps_exec("rm -f include/*.php");
		moveit("picstory/include/*.php","include");
		// data et js
		rrm("data");
		moveit("picstory/data","./");
		rrm("js");
		moveit("picstory/js","./");
		rrm("lng");
		moveit("picstory/lng","./");
		// tous les fichiers !
		rrm("changelog.txt");
		moveit("picstory/changelog.txt","./");
		rrm("COPYING");
		moveit("picstory/COPYING","./");
		// les php
		//ps_exec("rm -f *.php");
		rrmex("*.php","picstoryupdate");
		moveit("picstory/*.php","./");
		// nettoyage
		printRT(_translate("Nettoyage"));
		rrm("picstory",true);
		rrm("*.zip",true);
		rrm("log/*.log",true);
		rrm("tasks/*.tsk",true);
		ask_something(_translate("Mise à jour du programme terminée!")."<br><br>"._translate("Mise à jour des polices de caractères"),_translate("Ok"),'picstoryupdatenew.php');
		$_SESSION['phase']++;
		break;
		/* polices et fin */
	case 5:
        rrm("picstoryfonts");
        rrm("picstoryfonts.zip");

		printRT("Téléchargement de l'archive ".PS_MAJADRS."/picstoryfonts.zip");
		if (!ps_exec("wget ".PS_MAJADRS."/picstoryfonts.zip"))
		{
			moveit("include/version.old","include/version.php");
			$_SESSION=array();
			exit (_translate("Erreur du chargement de l'archive"));
		}
		printRT(_translate("Décompression"));
		if (!ps_exec("unzip picstoryfonts.zip",true))
		{
			moveit("include/version.old","include/version.php");
			rrm("picstoryfonts.zip");
			rrm("picstoryfonts");
			$_SESSION=array();
			exit (_translate("Erreur lors de la décompression")." (3).");
		}
		// copie de la nouvelle version des polices
		copyfonts();
		rrm("fonts/fonts.*");		// forcer maj
		ask_something(_translate("Mise à jour terminée !")."<br>"._translate("Retour à Picstory."),_translate("Ok"),'index.php');
		if (file_exists("picstoryupdatenew.php"))	ps_exec("mv picstoryupdatenew.php picstoryupdate.php");

		rrm("picstoryfonts.zip");
		rrm("picstoryfonts");
		$_SESSION=array();
		break;
}

/* demander mot de passe */
function ask_mdp()
{
		print("<div class='formuc'>");
		print("<form method='post' action='picstoryupdate.php'>");
		print("<div>"._translate("Mot de passe administrateur :")."</div>");
		print("<input type='password' name='password'/>");
		print("<input type='submit' value='"._translate("Envoyer")."'/>");
		print("</form></div>");
}
/* avertissement */
function ask_something($text,$ask,$link)
{
    if (!file_exists($link))    $link='picstoryupdate.php';
	print("<div class='formu'>$text</div>");
	print("<form method='post' action='$link'>");
	print("<input type='submit' value='$ask'/>");
	print("</form>");
}
/* imprimer et vider le cache */
function printRT($texte)
{
	print($texte."<br>");
	ob_flush();
	flush();
}
/* Exécution des commandes exec */
function ps_exec($cmd,$quiet=false)
{
	putenv('LANG=fr_FR.UTF-8');
	exec($cmd,$out,$status);
	if (!$quiet)	foreach($out as $line)	print("$line<br>");
	if ($status)
	{  return false;
        print("Status : $status<br>");
    }
	else			return true;
}
// recursively remove a directory
function rrm($dir,$quiet=false)
{
	if (!glob($dir))		return true;
	return	ps_exec("rm -rf $dir",$quiet);
}
function rrmex($dir,$exclude)
{
	$liste=glob($dir);
	if (!$liste)	return;
	for ($i=0;$i<count($liste);$i++)	if (strpos($liste[$i],$exclude)===false)		rrm($liste[$i]);
}
// move...
function moveit($src,$dst)
{
	return ps_exec("mv -f $src $dst");
}
/* fonction de traduction */
function _translate($text)
{
	$lng=$_SESSION['ADMlng'];
	if ($lng=='fr')	return htmlspecialchars($text,ENT_QUOTES);

	if (file_exists("lng/$lng/$lng.php")&&count($_SESSION["ADMtrans"])<2)	include_once("lng/$lng/$lng.php");
	$key=md5($text);
	if (isset($_SESSION["ADMtrans"][$key]))	return htmlspecialchars($_SESSION["ADMtrans"][$key],ENT_QUOTES);
	else									return htmlspecialchars($text,ENT_QUOTES);
}
function copyfonts()
{
	/* extraire un ttf d'une archive zip */
	$ziplist=glob("picstoryfonts/*.zip");
	if (!file_exists("TTF"))	mkdir("TTF");
	else									ps_exec("rm TTF/*",true);
	for ($i=0;$i<count($ziplist);$i++)	extractttf($ziplist[$i],"fonts");
	exec("rm -rf TTF");
}
/* utils */
function extractttf($zip,$destdir)
{
	require_once "include/ttfinfo.php";
	exec("unzip $zip \*.ttf -d TTF");
	// scan du répertoire ttf
	// première sélection
	$ttflist=glob("TTF/*.ttf");
	$selttf=array();
	$realn=array();
	$first=$ttflist[0];
	for($i=0;$i<count($ttflist);$i++)
	{
		$fontinfo=getFontInfo($ttflist[$i]);
		if ($fontinfo[2]=="Regular")
		{
			$realn[]=$fontinfo[1];
			$selttf[]=$ttflist[$i];
		}
	}
	$nb=count($selttf);
	/* aucune sélection, on prend la première police */
	if (!$nb && count($ttflist))
	{
		$nb++;
		$selttf[0]=$ttflist[0];
	}
	/* rien...*/
	if (!$nb)
	{
		print("Aucune police ttf sélectionnée dans $zip\n");
	}
	else
	{
		//print("$nb police(s) dans $zip\n");
		$font=trifont($selttf,$realn);
		print("$font / ");
		$simple=pathinfo($font);
		if (!file_exists($destdir."/".$simple["filename"]))	exec("mv \"".$font."\" $destdir");
	}
}
function trifont($list,$nom)
{
	if (count($list)==1)	return $list[0];
	// recherche de regular dans le nom)
	$retour="";
	$len=255;
	for($i=0;$i<count($list);$i++)
	{
		//print("cherche : ".$list[$i]." / ".$nom[$i]."\n");
		if (strlen($nom[$i])<$len)
		{
			$len=strlen($nom[$i]);
			$retour=$list[$i];
		}
	}
	// recherche du nom contenant "font"
	// par dépit...
	if (!$retour)	$retour=$list[0];
	return $retour;
}
?>
</body>
</html>
